/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IMergeTreeAnnotateMsg } from "./ops.js";
import { PropertySet } from "./properties.js";
/**
 * @alpha
 */
export declare enum PropertiesRollback {
    /** Not in a rollback */
    None = 0,
    /** Rollback */
    Rollback = 1
}
/**
 * @alpha
 */
export declare class PropertiesManager {
    private pendingKeyUpdateCount;
    ackPendingProperties(annotateOp: IMergeTreeAnnotateMsg): void;
    private decrementPendingCounts;
    addProperties(oldProps: PropertySet, newProps: PropertySet, seq?: number, collaborating?: boolean, rollback?: PropertiesRollback): PropertySet;
    copyTo(oldProps: PropertySet, newProps: PropertySet | undefined, newManager: PropertiesManager): PropertySet | undefined;
    /**
     * @returns whether all valid (i.e. defined) entries of the property bag are pending
     */
    hasPendingProperties(props: PropertySet): boolean;
    hasPendingProperty(key: string): boolean;
}
//# sourceMappingURL=segmentPropertiesManager.d.ts.map